<?php

/**
 * Fired during Visidea activation.
 *
 * @link       https://visidea.ai
 * @since      1.0.0
 *
 * @package    Visidea
 * @subpackage Visidea/includes
 */

class Visidea_Activator {

  public static function schedule_cron() {

    // Obtain cron hook name
    $hook_name = get_option('cron_hook');
    // Schedule hook calls
    if (!wp_next_scheduled($hook_name))
      wp_schedule_event(time(), 'half_hour', $hook_name);
  }

  /**
   * Initialize settings and create data files.
   *
   * @since    1.0.0
   */
  public static function activate() {

    // To add new files, ad an fname here and to the fnames array.
    // Then, add a default column to the columns array at the same index.

    // Initialize database host and public token
    $database_id = "";
    $public_token = "";
    $private_token = "";

    // Change the three next variables if you intend to use different columns in CSV exports.
    $interactions_columns = 'item_id;action;user_id;timestamp' . "\n";
    $items_dump_columns ="item_id;name;brand_id;brand_name;price;market_price;".
      "discount;page_ids;page_names;url;images\n";
    $users_dump_columns = "user_id;email;name;surname;address;city;zip;state;".
      "country;locale;lifetimeDuration;ordersCount;totalSpent;createdAt\n";

    // Save default columns as WP_Options
    add_option('ry_database_id', $database_id);
    add_option('ry_public_token', $public_token);
    add_option('ry_private_token', $private_token);
    add_option('ry_interactions_columns', $interactions_columns);
    add_option('ry_items_columns', $items_dump_columns);
    add_option('ry_users_columns', $users_dump_columns);

  }
}
